diff --git a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
index c1503f067..479940caa 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
@@ -27,14 +27,14 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
 
     @Override
     public void doRender(Tessellator tessellator, TileEntityFlag tileEntity, double x, double y, double z, float partialTick) {
-        World theWorld = Minecraft.getMinecraft(this).theWorld;
+        World theWorld = Minecraft.getMinecraft(this).currentWorld;
         int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
         boolean shortPole = blockUnder == Blocks.FLAG.id;
 
-        WindProvider theWind = mc.theWorld.getWorldType().getWindManager();
+        WindProvider theWind = mc.currentWorld.getWorldType().getWindManager();
 
-        float windDirection = theWind.getWindDirection(mc.theWorld, 0.0f, 500.0f, 0.0f) * 360f;
-        float windIntensity = theWind.getWindIntensity(mc.theWorld, 0.0f, 500.0f, 0.0f);
+        float windDirection = theWind.getWindDirection(mc.currentWorld, 0.0f, 500.0f, 0.0f) * 360f;
+        float windIntensity = theWind.getWindIntensity(mc.currentWorld, 0.0f, 500.0f, 0.0f);
         
         doRender(tileEntity, x, y, z, partialTick, shortPole, windDirection, windIntensity);
     }
@@ -42,7 +42,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
     private long lastTick = 0;
     public void doRender(TileEntityFlag tileEntityFlag, double x, double y, double z, float partialTick, boolean shortPole, float windDirection, float windIntensity)
     {
-        World theWorld = Minecraft.getMinecraft(this).theWorld;
+        World theWorld = Minecraft.getMinecraft(this).currentWorld;
         if (flagRenderer == null)
         {
             flagRenderer = new FlagRenderer(renderDispatcher.textureManager);
diff --git a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java
index 2c417b1a9..6abb59749 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java
@@ -35,7 +35,7 @@ public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMes
         renderEntity.y = renderEntity.yo = tileEntity.y + 0.5;
         renderEntity.z = renderEntity.zo = tileEntity.z + 0.5;
         
-        float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        float lightLevel = Minecraft.getMinecraft(this).currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
         BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
diff --git a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
index 16a60890f..6804b71ea 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
@@ -85,7 +85,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glPopMatrix();
         
         // Render text
-        float lightLevel = mc.theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        float lightLevel = mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
             lightLevel = 1f;
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
index bd201d098..0fcada15e 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraSleeping.java
@@ -33,7 +33,7 @@ public class EntityCameraSleeping
     public EntityCameraSleeping(Minecraft mc, Mob entity, int xb, int yb, int zb, double xs, double ys, double zs, double yRotS, double xRotS)
     {
         super(mc, entity);
-        int metadata = mc.theWorld.getBlockMetadata(xb, yb, zb) & 3;
+        int metadata = mc.currentWorld.getBlockMetadata(xb, yb, zb) & 3;
 
         while (yRotS < 0)
         {
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
index bb648f71e..43e2cbf51 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
@@ -48,7 +48,7 @@ public class EntityCameraThirdPersonRear
 
         for(int i = 0; i <= numSteps; i++)
         {
-            HitResult hitResult = mc.theWorld.checkBlockCollisionBetweenPoints(
+            HitResult hitResult = mc.currentWorld.checkBlockCollisionBetweenPoints(
                     Vec3.getTempVec3(x, y, z),
                     Vec3.getTempVec3(x - i * dx, y - i * dy, z - i * dz),
                     false,
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
index f5c469ca0..374119450 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -26,14 +26,14 @@ public class Colorizer {
 	
 	public void setup(Minecraft minecraft, List<Season> seasons) {
 		texturePack = null;
-		if(minecraft.theWorld == null) {
+		if(minecraft.currentWorld == null) {
 			return;
 		}
 		
 		String path = null;
 
 		// First, check for worldtype overrides
-		WorldType worldType = minecraft.theWorld.worldType;
+		WorldType worldType = minecraft.currentWorld.worldType;
 		if(worldType == WorldTypes.OVERWORLD_HELL) {
 			path = "/assets/minecraft/textures/colormap/" + this.name + "/hell.png";
 			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
@@ -45,7 +45,7 @@ public class Colorizer {
 		
 		if(texturePack == null) {
 			// Check if there is a colormap for the current dimension
-			Dimension dimension = minecraft.theWorld.dimension;
+			Dimension dimension = minecraft.currentWorld.dimension;
 			String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
 			path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
 			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);	
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index b0b69bfdd..8ee4b034c 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -86,7 +86,7 @@ public class Colorizers {
 	}
 	
 	public static void update(boolean force) {
-		World world = mc.theWorld;
+		World world = mc.currentWorld;
 		if(world == null) {
 			lastDimension = null;
 			return;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
index 415522e9a..d700b8fcd 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
@@ -13,11 +13,11 @@ public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 	@Override
 	public double getAngle() {
 		double d = 0.0;
-		if (mc.theWorld != null && mc.thePlayer != null)
+		if (mc.currentWorld != null && mc.thePlayer != null)
 		{
-			if (mc.theWorld.getSeasonManager() instanceof SeasonManagerCycle)
+			if (mc.currentWorld.getSeasonManager() instanceof SeasonManagerCycle)
 			{
-				SeasonManagerCycle cycleManager = (SeasonManagerCycle) mc.theWorld.getSeasonManager();
+				SeasonManagerCycle cycleManager = (SeasonManagerCycle) mc.currentWorld.getSeasonManager();
 				float f = cycleManager.getYearProgress() - 0.25f;
 				d = f * Math.PI * 2;
 			}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
index b130ffe5b..90b8e3f2d 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
@@ -13,10 +13,10 @@ public class DynamicTextureClock extends DynamicTextureAbstractClock{
 	@Override
 	public double getAngle() {
 		double d = 0.0;
-		if(mc.theWorld != null && mc.thePlayer != null) {
-			float f = mc.theWorld.getCelestialAngle(1.0f);
+		if(mc.currentWorld != null && mc.thePlayer != null) {
+			float f = mc.currentWorld.getCelestialAngle(1.0f);
 			d = -f * Math.PI * 2;
-			if(mc.theWorld.dimension == Dimension.NETHER) {
+			if(mc.currentWorld.dimension == Dimension.NETHER) {
 				d = Math.random() * Math.PI * 2;
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index 81fd413d3..ee9948a9a 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -65,12 +65,12 @@ public class DynamicTextureCompass extends DynamicTexture {
 		}
 		
 		double angle = 0.0D;
-		if(this.mc.theWorld != null && this.mc.thePlayer != null) {
-			ChunkCoordinates var21 = this.mc.theWorld.getSpawnPoint();
+		if(this.mc.currentWorld != null && this.mc.thePlayer != null) {
+			ChunkCoordinates var21 = this.mc.currentWorld.getSpawnPoint();
 			double var23 = (double)var21.x - this.mc.thePlayer.x;
 			double var25 = (double)var21.z - this.mc.thePlayer.z;
 			angle = (double)(this.mc.thePlayer.yRot - 90.0F) * PI / 180.0D - Math.atan2(var25, var23);
-			if(this.mc.theWorld.dimension == Dimension.NETHER) {
+			if(this.mc.currentWorld.dimension == Dimension.NETHER) {
 				angle = Math.random() * PI * 2;
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index cf80aed37..fce2fb450 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -7,17 +7,17 @@ import net.minecraft.client.render.model.ModelBoat;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.blockentity.TileEntityRendererFlag;
-import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.wind.WindProvider;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            Render, ModelBoat, BoatEntity, MathHelper,
+//            Render, ModelBoat, EntityBoat, MathHelper,
 //            ModelBase, Entity
 
-public class EntityRendererBoat extends EntityRenderer<BoatEntity>
+public class EntityRendererBoat extends EntityRenderer<EntityBoat>
 {
 	
 	private final Minecraft mc = Minecraft.getMinecraft(this);
@@ -30,7 +30,7 @@ public class EntityRendererBoat extends EntityRenderer<BoatEntity>
     }
 
     @Override
-    public void render(Tessellator tessellator, BoatEntity entity, double x, double y, double z,
+    public void render(Tessellator tessellator, EntityBoat entity, double x, double y, double z,
                        float yaw, float partialTick)
     {
         GL11.glPushMatrix();
@@ -48,7 +48,7 @@ public class EntityRendererBoat extends EntityRenderer<BoatEntity>
         }
         if (entity.tileEntityFlag != null)
         {
-            World theWorld = mc.theWorld;
+            World theWorld = mc.currentWorld;
             WindProvider theWind = theWorld.getWorldType().getWindManager();
 
             float windAngle = theWind.getWindDirection(theWorld, (float) x, (float) y, (float) z) * 360f + (180 - yaw);
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 726e3ac41..170c5336f 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -41,11 +41,11 @@ public class ItemModelMap extends ItemModelStandard {
         // Apply appropriate brightness
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-        	LightmapHelper.setLightmapCoord(mc.theWorld.getLightmapCoord(blockX, blockY, blockZ, 0));
+        	LightmapHelper.setLightmapCoord(mc.currentWorld.getLightmapCoord(blockX, blockY, blockZ, 0));
         }else if(mc.fullbright) {
         	
         }else {
-        	brightness = mc.theWorld.getLightBrightness(blockX, blockY, blockZ);
+        	brightness = mc.currentWorld.getLightBrightness(blockX, blockY, blockZ);
         }
         GL11.glColor4f(brightness, brightness, brightness, 1.0f);
 
@@ -111,7 +111,7 @@ public class ItemModelMap extends ItemModelStandard {
         tessellator.addVertexWithUV(-expansion,     -expansion,      0.0D, 0.0D, 0.0D);
         tessellator.draw();
 
-        ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(stack, mc.theWorld);
+        ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(stack, mc.currentWorld);
         if (mapData == null) return;
         renderMapInstance.renderMap(mc.textureManager, mapData, brightness);
     }
diff --git a/src/main/java/net/minecraft/client/render/shader/Shaders.java b/src/main/java/net/minecraft/client/render/shader/Shaders.java
index 0c0a42649..fd05ffae4 100644
--- a/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -6,7 +6,10 @@ import static org.lwjgl.opengl.GL11.*;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.camera.CameraUtil;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.item.IArmorItem;
+import net.minecraft.core.item.ItemStack;
 
 public abstract class Shaders {
 	
@@ -70,18 +73,21 @@ public abstract class Shaders {
 		shader.uniformFloat("fxaa", minecraft.gameSettings.fxaa.value);
 		shader.uniformFloat("heatHaze", minecraft.gameSettings.heatHaze.value ? minecraft.ppm.heatHaze : 0.0f);
 		shader.uniformInt("bloom", minecraft.gameSettings.bloom.value);
-		shader.uniformInt("dimension", minecraft.theWorld != null && minecraft.theWorld.dimension != null ? minecraft.theWorld.dimension.id : 0);
+		shader.uniformInt("dimension", minecraft.currentWorld != null && minecraft.currentWorld.dimension != null ? minecraft.currentWorld.dimension.id : 0);
 		shader.uniformInt("cbCorrectionMode", minecraft.gameSettings.colorblindnessFix.value.ordinal());
 
+		ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
+		shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id ? 1 : 0);
+
 		int isEyeInLiquid = 0;
 		float celestialAngle = 0.0f;
-		if(minecraft.thePlayer != null && minecraft.theWorld != null && minecraft.activeCamera != null) {
-			if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.theWorld, Material.lava, partialTicks)) {
+		if(minecraft.thePlayer != null && minecraft.currentWorld != null && minecraft.activeCamera != null) {
+			if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Material.lava, partialTicks)) {
 				isEyeInLiquid = 2;
-			}else if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.theWorld, Material.water, partialTicks)) {
+			}else if(CameraUtil.isUnderLiquid(minecraft.activeCamera, minecraft.currentWorld, Material.water, partialTicks)) {
 				isEyeInLiquid = 1;
 			}
-			celestialAngle = minecraft.theWorld.getCelestialAngle(partialTicks);
+			celestialAngle = minecraft.currentWorld.getCelestialAngle(partialTicks);
 		}
 		shader.uniformInt("isEyeInLiquid", isEyeInLiquid);
 		shader.uniformFloat("celestialAngle", celestialAngle);
diff --git a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 554a7f010..3d5b29762 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -136,9 +136,9 @@ public class ShadersRenderer implements Renderer {
 			glUniformMatrix4fv(cloudsShader.getUniform("gbufferProjectionInverse"), false, matrixBuffer);
 			
 			int isEyeInLiquid;
-			if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.lava, partialTicks)) {
+			if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.lava, partialTicks)) {
 				isEyeInLiquid = 2;
-			}else if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.water, partialTicks)) {
+			}else if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTicks)) {
 				isEyeInLiquid = 1;
 			}else {
 				isEyeInLiquid = 0;
diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
new file mode 100644
index 000000000..ae91f7a3d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
@@ -0,0 +1,76 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeFX {
+    public final WorldType worldType;
+
+    private boolean hasClouds = true;
+    private boolean hasSky = true;
+    private boolean hasGround = true;
+    private boolean hasAurora = false;
+    private Float cloudHeight = null;
+
+    public WorldTypeFX(WorldType worldType) {
+        this.worldType = worldType;
+    }
+
+    public WorldTypeFX setHasClouds(boolean flag) {
+        this.hasClouds = flag;
+        return this;
+    }
+
+    public WorldTypeFX setHasSky(boolean flag) {
+        this.hasSky = flag;
+        return this;
+    }
+
+    public WorldTypeFX setHasGround(boolean flag) {
+        this.hasGround = flag;
+        return this;
+    }
+
+    public WorldTypeFX setHasAurora(boolean flag) {
+        this.hasAurora = flag;
+        return this;
+    }
+
+    public WorldTypeFX setCloudHeight(float cloudHeight) {
+        this.cloudHeight = cloudHeight;
+        return this;
+    }
+
+    public boolean hasClouds() {
+        return hasClouds;
+    }
+
+    public boolean hasSky() {
+        return hasSky;
+    }
+
+    public float getCloudHeight() {
+        if (cloudHeight == null) {
+            return (worldType.getMaxY() + 1) - 20;
+        }
+        return cloudHeight;
+    }
+
+    public boolean hasGround() {
+        return hasGround;
+    }
+
+    public boolean hasAurora() {
+        return hasAurora;
+    }
+
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        return Vec3.getTempVec3(1.0, 1.0, 1.0);
+    }
+
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        return new float[4];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java
new file mode 100644
index 000000000..d4fd88b6e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDispatcher.java
@@ -0,0 +1,87 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.client.util.dispatch.Dispatcher;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypes;
+
+public class WorldTypeFXDispatcher extends Dispatcher<WorldType, WorldTypeFX> {
+    private static WorldTypeFXDispatcher instance = new WorldTypeFXDispatcher();
+
+    public static WorldTypeFXDispatcher getInstance() {
+        return instance;
+    }
+
+    private WorldTypeFXDispatcher() {
+        instance = this;
+        addDispatch(new WorldTypeFX(WorldTypes.DEBUG)
+            .setCloudHeight(128f - 20f)
+            .setHasGround(false));
+        addDispatch(new WorldTypeFXEmpty(WorldTypes.EMPTY)
+            .setCloudHeight(128f - 20f)
+            .setHasGround(false));
+
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_EXTENDED)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_DEFAULT)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_FLOATING)
+            .setHasAurora(true)
+            .setCloudHeight(32f));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_AMPLIFIED)
+            .setHasAurora(true)
+            .setCloudHeight(128f - 20f));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_RETRO)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_ISLANDS)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_WINTER)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_WOODS)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_PARADISE)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_INLAND)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_CLASSIC)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_INDEV)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFXOverworld(WorldTypes.OVERWORLD_SKYBLOCK)
+            .setHasAurora(true));
+        addDispatch(new WorldTypeFX(WorldTypes.OVERWORLD_HELL));
+
+        addDispatch(new WorldTypeFX(WorldTypes.FLAT)
+            .setCloudHeight(256f - 20f));
+
+        addDispatch(new WorldTypeFXNether(WorldTypes.NETHER_DEFAULT)
+            .setHasClouds(false)
+            .setHasSky(false));
+        addDispatch(new WorldTypeFXNether(WorldTypes.NETHER_SKYBLOCK)
+            .setHasClouds(false)
+            .setHasSky(false));
+
+        addDispatch(new WorldTypeFXParadise(WorldTypes.PARADISE_DEFAULT)
+            .setCloudHeight(8f)
+            .setHasGround(false));
+
+        for (WorldType worldType : Registries.WORLD_TYPES) {
+            assert dispatches.containsKey(worldType) : "WorldType " + worldType.getLanguageKey() + " is missing a WorldTypeFX!";
+        }
+    }
+
+    public void addDispatch(WorldTypeFX worldTypeFX) {
+        addDispatch(worldTypeFX.worldType, worldTypeFX);
+    }
+
+    @Override
+    public void addDispatch(WorldType key, WorldTypeFX value) {
+        assert !dispatches.containsKey(key) : "WorldType " + key.getLanguageKey() + " is already assigned a WorldTypeFX! " + value.getClass();
+        super.addDispatch(key, value);
+    }
+
+    @Override
+    protected WorldTypeFX getDefault() {
+        return dispatches.get(WorldTypes.EMPTY);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
new file mode 100644
index 000000000..00c54f298
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeFXEmpty extends WorldTypeFX{
+    public WorldTypeFXEmpty(WorldType worldType) {
+        super(worldType);
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float f2 = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        if (f2 < 0.0F) {
+            f2 = 0.0F;
+        }
+        if (f2 > 1.0F) {
+            f2 = 1.0F;
+        }
+        float r = 0.7529412F;
+        float g = 0.8470588F;
+        float b = 1.0F;
+        r *= f2 * 0.94F + 0.06F;
+        g *= f2 * 0.94F + 0.06F;
+        b *= f2 * 0.91F + 0.09F;
+        return Vec3.getTempVec3(r, g, b);
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        float[] sunriseCol = new float[4];
+        float f2 = 0.4F;
+        float f3 = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F) - 0.0F;
+        float f4 = -0F;
+        if (f3 >= f4 - f2 && f3 <= f4 + f2) {
+            float c = ((f3 - f4) / f2) * 0.5F + 0.5F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
+            a *= a;
+            sunriseCol[0] = c * 0.3F + 0.7F;
+            sunriseCol[1] = c * c * 0.7F + 0.2F;
+            sunriseCol[2] = c * c * 0.0F + 0.2F;
+            sunriseCol[3] = a;
+            return sunriseCol;
+        } else {
+            return null;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
new file mode 100644
index 000000000..9c7e606a1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXNether.java
@@ -0,0 +1,35 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeFXNether extends WorldTypeFX{
+    public WorldTypeFXNether(WorldType worldType) {
+        super(worldType);
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        return new float[4];
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            float r = ((color >> 16) & 0xFF) / 255.0f;
+            float g = ((color >> 8) & 0xFF) / 255.0f;
+            float b = (color & 0xFF) / 255.0f;
+            return Vec3.getTempVec3(r, g, b);
+        }
+        return Vec3.getTempVec3(0.0, 0.0, 0.0);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java
new file mode 100644
index 000000000..039a25abb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXOverworld.java
@@ -0,0 +1,62 @@
+package net.minecraft.client.render.worldtype;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeFXOverworld extends WorldTypeFX{
+    public WorldTypeFXOverworld(WorldType worldType) {
+        super(worldType);
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        float[] sunriseCol = new float[4];
+        float sunriseMinimum = 0.4F;
+
+        // Gives a value that goes from 1 to -1 to 1 over the course of a day
+        float sunrisePresence = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F);
+        float middle = 0F;
+        if (sunrisePresence >= middle - sunriseMinimum && sunrisePresence <= middle + sunriseMinimum) {
+            float c = ((sunrisePresence - middle) / sunriseMinimum) * 0.5F + 0.5F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
+            a *= a;
+            sunriseCol[0] = c * 0.3F + 0.7F;
+            sunriseCol[1] = c * c * 0.7F + 0.2F;
+            sunriseCol[2] = c * c * 0.0F + 0.2F;
+            sunriseCol[3] = a;
+            return sunriseCol;
+        } else {
+            return null;
+        }
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float dayProgress = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        dayProgress = MathHelper.clamp(dayProgress, 0.0f, 1.0f);
+        float r, g, b;
+
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            r = ((color >> 16) & 0xFF) / 255.0f;
+            g = ((color >> 8) & 0xFF) / 255.0f;
+            b = (color & 0xFF) / 255.0f;
+        } else {
+            r = 0.7529412f;
+            g = 0.8470588f;
+            b = 1.0f;
+        }
+        r *= dayProgress * 0.94f + 0.06f;
+        g *= dayProgress * 0.94f + 0.06f;
+        b *= dayProgress * 0.91f + 0.09f;
+        return Vec3.getTempVec3(r, g, b);
+    }
+}
